## glaxnimate-0.5.4.tar.lz

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2019-2023 Mattia Basaglia <dev@dragon.best>
# SPDX-License-Identifier: BSD-2-Clause

cmake_minimum_required (VERSION 3.5 FATAL_ERROR)
# cmake_policy(SET CMP0076 NEW)
cmake_policy(SET CMP0077 NEW)


project(Glaxnimate VERSION 0.5.4 LANGUAGES CXX)
set(PROJECT_SLUG "glaxnimate")
set(LIB_NAME_CORE "${PROJECT_SLUG}_core")
set(LIB_NAME_GUI "${PROJECT_SLUG}_gui")
set(LIB_NAME_PYTHON "${PROJECT_SLUG}_python_lib")
set(LIB_NAME_DESKTOP "${PROJECT_SLUG}_desktop")
set(DATA_INSTALL "share/${PROJECT_SLUG}/${PROJECT_SLUG}")
set(PROJECT_ID "org.mattbas.Glaxnimate")

set(PROJECT_HOMEPAGE_URL "https://glaxnimate.mattbas.org/")
set(URL_DOCS "https://glaxnimate.mattbas.org/")
set(URL_ISSUES "https://gitlab.com/mattbas/glaxnimate/-/issues")
set(URL_DONATE "https://glaxnimate.mattbas.org/donate/")

# You can use it to change the url used by `make docs`
set(DOCS_SITE_URL ${URL_DOCS} CACHE STRING "")
set(DOCS_REPO_URL "https://gitlab.com/mattbas/glaxnimate")
set(DOCS_CHAT_URL "https://t.me/Glaxnimate")

set(PROJECT_DESCRIPTION "Simple vector animation program")
set(PROJECT_MANINTAINER_NAME "Mattia Basaglia")
set(PROJECT_MANINTAINER_EMAIL "glanimate@mattbas.org")
set(PROJECT_MANINTAINER "${PROJECT_MANINTAINER_NAME} <${PROJECT_MANINTAINER_EMAIL}>")

option(MOBILE_UI "Build the mobile user interface" OFF)

if (ANDROID)
    set(MOBILE_UI ON)
endif()

if(MOBILE_UI)
    add_compile_definitions(MOBILE_UI)
endif()

# CMake modules
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake" "${CMAKE_CURRENT_SOURCE_DIR}/external/cmake-modules")
include(misc)
include(GetGitRevisionDescription)

# C++
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Git
set(VERSION_NAKED ${PROJECT_VERSION})
set(VERSION_SUFFIX "-git-" CACHE STRING "")

if (VERSION_SUFFIX STREQUAL "-git-")
    git_describe(GIT_DESC --tags)
    if ( NOT ${GIT_DESC} MATCHES ".*NOTFOUND" )
        set(PROJECT_VERSION ${GIT_DESC})
    endif()
elseif(VERSION_SUFFIX MATCHES "^\\..*")
    set(PROJECT_VERSION "${PROJECT_VERSION}${VERSION_SUFFIX}")
elseif(NOT VERSION_SUFFIX STREQUAL "")
    set(PROJECT_VERSION "${PROJECT_VERSION}+${VERSION_SUFFIX}")
endif()

message(STATUS "Building ${PROJECT_NAME} ${PROJECT_VERSION}")

# Snapcraft stuff here because we don't care if cmake fails on CI
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/deploy/snapcraft.in.yaml"
    "${CMAKE_CURRENT_BINARY_DIR}/snapcraft.yaml"
)
option(SNAP_IS_SUCH_A_PAIN "" OFF)
if ( SNAP_IS_SUCH_A_PAIN  )
    return()
endif()

# Fucking Windows being shit
if ( WIN32 )
    # Without this shit it gives a bunch of errors like this:
    # * referenced in section `.rdata' of * defined in discarded section `.gnu.linkonce.*`
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-lto")
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -fno-lto")
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fno-lto")
    set(CMAKE_INTERPROCEDURAL_OPTIMIZATION FALSE)
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
    set(CMAKE_ENABLE_EXPORTS TRUE)
endif()


# Python
if ( NOT ANDROID )
    find_program(PYTHON_PIP pip3)
    if(NOT PYTHON_PIP)
        find_program(PYTHON_PIP pip)
    endif()

    find_package(Python3 COMPONENTS Interpreter Development REQUIRED)
    message(STATUS ${Python3_EXECUTABLE})
    set(SCRIPTING_PY ON)
endif()

# Qt
#find_package(Qt5Qml QUIET)
set(QT_VERSION_MAJOR 5)
find_package(QT NAMES Qt5 Qt6 COMPONENTS Core QUIET)
find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Core Widgets Xml UiTools Concurrent Network Svg REQUIRED)
message(STATUS "Using Qt ${QT_VERSION_MAJOR}")



set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Potrace
option(GLAXNIMATE_SYSTEM_POTRACE "Use the system potrace libarary" ON)
if (NOT GLAXNIMATE_SYSTEM_POTRACE)
    message(STATUS "Using bundled potrace")
    set(CMAKE_C_COMPILE_OBJECT ${CMAKE_CXX_COMPILE_OBJECT})
    add_subdirectory(external/potrace/)
    set(Potrace_LIBRARIES potrace)
    include_directories(external/potrace/src/)
else()
    find_package(Potrace REQUIRED)
endif()

# Debug flags
if(CMAKE_BUILD_TYPE STREQUAL "")
    set(CMAKE_BUILD_TYPE "Debug")
endif()
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wall -pedantic -Wextra")
message(STATUS "${CMAKE_BUILD_TYPE} build")

# sub projects and stuff

if ( WIN32 )
    SET(BUILD_STATIC_LIBS OFF CACHE BOOL "")
    SET(BUILD_SHARED_LIBS ON CACHE BOOL "")
else ()
    SET(BUILD_STATIC_LIBS ON CACHE BOOL "")
    SET(BUILD_SHARED_LIBS OFF CACHE BOOL "")
endif()

add_subdirectory(external/QtAppSetup)

add_subdirectory(external/Qt-History-LineEdit)

add_subdirectory(src bin)

set(QTCOLORWIDGETS_DESIGNER_PLUGIN ON)
add_subdirectory(external/Qt-Color-Widgets EXCLUDE_FROM_ALL)

set(ALL_SOURCE_DIRECTORIES src)
find_sources(ALL_SOURCES *.cpp *.hpp)

add_subdirectory(data ${DATA_INSTALL})

find_package(Qt${QT_VERSION_MAJOR}Test QUIET)
if(${Qt${QT_VERSION_MAJOR}Test_FOUND})
    message(STATUS "Tests enabled")
    add_subdirectory(test)
endif()

add_subdirectory(docs)

# Doxygen

set(DOXYGEN_FOUND ON)
find_package(Doxygen QUIET)
if(DOXYGEN_FOUND)
    create_doxygen_target(doxygen)
endif(DOXYGEN_FOUND)

# Release

add_custom_target(
    release_0
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/deploy/release_0.sh ${CMAKE_CURRENT_BINARY_DIR}/CMakeCache.txt
)
add_custom_target(
    release_1
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/deploy/release_1.sh ${CMAKE_CURRENT_BINARY_DIR}/CMakeCache.txt
)
add_custom_target(
    release_check
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/deploy/release_check.py ${VERSION_NAKED}
)

# Misc files
if (ANDROID)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/android/android/version.gradle.in ${CMAKE_BINARY_DIR}/version.gradle)
endif()
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/deploy/org.mattbas.Glaxnimate.metainfo.xml DESTINATION share/metainfo)

# Packaging
# -- see https://gitlab.kitware.com/cmake/community/-/wikis/doc/cpack/PackageGenerators
set(CPACK_PACKAGE_CONTACT ${PROJECT_MANINTAINER})
set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY ${PROJECT_DESCRIPTION})

execute_process(COMMAND dpkg-architecture -qDEB_BUILD_ARCH OUTPUT_VARIABLE CPACK_DEBIAN_PACKAGE_ARCHITECTURE ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
set(CPACK_DEBIAN_PACKAGE_DEPENDS "libqt5xml5 (>= 5.10.0), libqt5widgets5 (>= 5.10.0), libpython3.10 (>= 3.10.0), zlib1g (>= 1:1.2.11), libpotrace0 (>= 1.16-2), libavformat58, libswscale5, qt5-image-formats-plugins, libarchive13")
set(CPACK_DEBIAN_PACKAGE_SECTION "graphics")
set(CPACK_DEBIAN_PACKAGE_HOMEPAGE ${PROJECT_HOMEPAGE_URL})

set(CPACK_BUNDLE_NAME ${PROJECT_NAME})
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/deploy/bundle.xml.plist"
    "${CMAKE_CURRENT_BINARY_DIR}/bundle.xml.plist"
)
set(CPACK_BUNDLE_PLIST "${CMAKE_CURRENT_BINARY_DIR}/bundle.xml.plist")
set(CPACK_BUNDLE_ICON "${CMAKE_CURRENT_BINARY_DIR}/glaxnimate.icns")

include(CPack)

=== data/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2019-2023 Mattia Basaglia <dev@dragon.best>
# SPDX-License-Identifier: BSD-2-Clause

set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM 1)

if ( ANDROID )

    # The breeze-icons package approach is inspired by https://invent.kde.org/frameworks/kirigami/-/blob/kf5/KF5Kirigami2Macros.cmake
    include(CMakeParseArguments)
    include(ExternalProject)


    function(android_package_breeze_icons)
        set(_multiValueArgs ICONS)
        cmake_parse_arguments(ARG "" "" "${_multiValueArgs}" ${ARGN} )

        if(NOT ARG_ICONS)
            message(FATAL_ERROR "No ICONS argument given to android_package_breeze_icons")
        endif()

        function(_find_breeze_icon icon varName)
            #HACKY
            SET(path "")
            file(GLOB_RECURSE path ${_BREEZEICONS_DIR}/icons/*/48/${icon}.svg )

            #search in other sizes as well
            if (path STREQUAL "")
                file(GLOB_RECURSE path ${_BREEZEICONS_DIR}/icons/*/32/${icon}.svg )
                if (path STREQUAL "")
                    file(GLOB_RECURSE path ${_BREEZEICONS_DIR}/icons/*/22/${icon}.svg )
                    if (path STREQUAL "")
                        file(GLOB_RECURSE path ${_BREEZEICONS_DIR}/icons/*/16/${icon}.svg )
                    endif()
                endif()
            endif()
            if (path STREQUAL "")
                file(GLOB_RECURSE path ${_BREEZEICONS_DIR}/icons/*/symbolic/${icon}.svg )
            endif()
            if (path STREQUAL "")
                return()
            endif()

            list(LENGTH path _count_paths)
            if (_count_paths GREATER 1)
                message(WARNING "Found more than one version of '${icon}': ${path}")
            endif()
            list(GET path 0 path)
            get_filename_component(path "${path}" REALPATH)

            SET(${varName} ${path} PARENT_SCOPE)
        endfunction()

        if (BREEZEICONS_DIR AND NOT EXISTS ${BREEZEICONS_DIR})
            message(FATAL_ERROR "BREEZEICONS_DIR variable does not point to existing dir: \"${BREEZEICONS_DIR}\"")
        endif()

        set(_BREEZEICONS_DIR "${BREEZEICONS_DIR}")

        if(NOT _BREEZEICONS_DIR AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/icons/breeze-icons/icons")
            set(_BREEZEICONS_DIR "${CMAKE_CURRENT_SOURCE_DIR}/icons/breeze-icons")
        endif()

        #FIXME: this is a terrible hack
        if(NOT _BREEZEICONS_DIR)
            set(_BREEZEICONS_DIR "${CMAKE_BINARY_DIR}/breeze-icons/src/breeze-icons")

            # replacement for ExternalProject_Add not yet working
            # first time config?
            if (NOT EXISTS ${_BREEZEICONS_DIR})
                find_package(Git)
                execute_process(COMMAND ${GIT_EXECUTABLE} clone --depth 1 --branch kf5 https://invent.kde.org/frameworks/breeze-icons.git ${_BREEZEICONS_DIR})
            endif()

            # external projects are only pulled at make time, not configure time
            # so this is too late to work with the _find_breeze_icon() method
            # _find_breeze_icon() would need to be turned into a target/command
            if (FALSE)
            ExternalProject_Add(
                breeze-icons
                PREFIX breeze-icons
                GIT_REPOSITORY https://invent.kde.org/frameworks/breeze-icons.git
                CONFIGURE_COMMAND ""
                BUILD_COMMAND ""
                INSTALL_COMMAND ""
                LOG_DOWNLOAD ON
            )
            endif()
        endif()

        message (STATUS "Using ${_BREEZEICONS_DIR} as breeze dir")
        message (STATUS "Found external breeze icons:")
        foreach(_iconName ${ARG_ICONS})
            set(_iconPath "")
            _find_breeze_icon(${_iconName} _iconPath)
            message (STATUS ${_iconPath})
            if (EXISTS ${_iconPath})
                install(FILES ${_iconPath} DESTINATION ${DATA_INSTALL}/icons/icons RENAME ${_iconName}.svg)
            else()
                message (WARNING "${_iconName} not found")
            endif()
        endforeach()

        #generate an index.theme that qiconloader can understand
        file(WRITE ${CMAKE_BINARY_DIR}/index.theme "[Icon Theme]\nName=Breeze\nDirectories=icons\n[icons]\nSize=32\nType=Scalable")
        install(FILES ${CMAKE_BINARY_DIR}/index.theme DESTINATION ${DATA_INSTALL}/icons)
    endfunction()

    android_package_breeze_icons(ICONS
        telegram
        edit-cut
        edit-copy
        edit-paste
        edit-delete
        edit-undo
        edit-redo
        edit-select
        edit-node
        edit-clear-all
        document-new
        document-open
        document-save
        document-save-as
        document-import
        document-export
        document-properties
        keyframe-add
        keyframe-remove
        keyframe-record
        view-preview
        player-time
        fill-color
        object-stroke-style
        question
        draw-brush
        draw-bezier-curves
        draw-freehand
        draw-rectangle
        draw-ellipse
        draw-polygon-star
        draw-text
        shapes
        overflow-menu
        media-playback-start
        media-playlist-repeat
        go-first
        go-previous
        go-next
        go-last
        layer-lower
        layer-raise
        dialog-layers
        smiley-shape
    )

    #get_target_property(ASSETS_PATH ${PROJECT_SLUG}_apk assets)
    #file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/images DESTINATION ${ASSETS_PATH})
    #file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/templates DESTINATION ${ASSETS_PATH})
else()
    file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/icons/breeze-icons/icons DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/icons/)
    file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/icons/breeze-icons/icons-dark DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/icons/)
    install(DIRECTORY icons/breeze-icons/icons DESTINATION ${DATA_INSTALL}/icons PATTERN *@* EXCLUDE)
    install(DIRECTORY icons/breeze-icons/icons-dark DESTINATION ${DATA_INSTALL}/icons PATTERN *@* EXCLUDE)

    file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/themes DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
    install(DIRECTORY themes DESTINATION ${DATA_INSTALL})

    file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/lib/python-lottie/lib/lottie DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/lib/)
    install(DIRECTORY lib/python-lottie/lib/lottie DESTINATION ${DATA_INSTALL}/lib/)

    file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/emoji DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
    install(DIRECTORY emoji DESTINATION ${DATA_INSTALL})
endif()

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/palettes DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
install(DIRECTORY palettes DESTINATION ${DATA_INSTALL})

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/images DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
install(DIRECTORY images DESTINATION ${DATA_INSTALL})

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/templates DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
install(DIRECTORY templates DESTINATION ${DATA_INSTALL})

# Translation
include(../cmake/qt.cmake)
set(ALL_SOURCE_DIRECTORIES ${CMAKE_SOURCE_DIR}/src)
create_qt_linguist_translations(
    TARGET translations
    TRANSLATIONS
    translations/glaxnimate_en_US.ts
    translations/glaxnimate_en_GB.ts
    translations/glaxnimate_es.ts
    translations/glaxnimate_it.ts
    translations/glaxnimate_de.ts
    translations/glaxnimate_fr.ts
    translations/glaxnimate_zh_CN.ts
    DESTINATION
    ${CMAKE_CURRENT_BINARY_DIR}/translations/
    SOURCES
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_SOURCE_DIR}/external
)
install(FILES ${LINGUIST_OUTPUT_FILES} DESTINATION ${DATA_INSTALL}/translations/)

# Desktop
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/glaxnimate.in.desktop ${CMAKE_CURRENT_BINARY_DIR}/glaxnimate.desktop)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/glaxnimate.desktop DESTINATION ${DATA_INSTALL})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/glaxnimate.desktop DESTINATION share/applications RENAME ${PROJECT_ID}.desktop)

# Misc
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/../AUTHORS.md ${CMAKE_CURRENT_BINARY_DIR}/AUTHORS.md COPYONLY)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/../AUTHORS.md DESTINATION ${DATA_INSTALL})

# Icon
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/logo/logo.svg ${CMAKE_CURRENT_BINARY_DIR}/images/${PROJECT_SLUG}.svg COPYONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/logo/file-icon.svg ${CMAKE_CURRENT_BINARY_DIR}/images/${PROJECT_SLUG}-file.svg COPYONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/logo/logo.svg ${CMAKE_CURRENT_SOURCE_DIR}/images/logo.svg COPYONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/images/${PROJECT_SLUG}.svg DESTINATION share/icons/hicolor/scalable/apps/ )
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/images/${PROJECT_SLUG}.svg DESTINATION share/icons/hicolor/scalable/apps/ RENAME ${PROJECT_ID}.svg )

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/images/${PROJECT_SLUG}.png
    COMMAND inkscape ${CMAKE_CURRENT_SOURCE_DIR}/logo/logo.svg -o ${CMAKE_CURRENT_SOURCE_DIR}/images/${PROJECT_SLUG}.png
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/logo/logo.svg
)
add_custom_target(
    logo_png
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/images/${PROJECT_SLUG}.png
)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/images/${PROJECT_SLUG}.png DESTINATION share/icons/hicolor/512x512/apps )
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/images/${PROJECT_SLUG}.svg DESTINATION share/icons/hicolor/512x512/apps/ RENAME ${PROJECT_ID}.png )

# Plugins
install(DIRECTORY plugins DESTINATION ${DATA_INSTALL})

function(plugin name)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/plugins/${name}/plugin.json ${CMAKE_CURRENT_BINARY_DIR}/plugins/${name}/plugin.json COPYONLY)
    foreach(file ${ARGN})
        configure_file(${CMAKE_CURRENT_SOURCE_DIR}/plugins/${name}/${file} ${CMAKE_CURRENT_BINARY_DIR}/plugins/${name}/${file} COPYONLY)
    endforeach()
endfunction()

plugin(
    Hello
    hello_world.py
)

plugin(
    ReplaceColor
    replace_color.py
    replace.ui
)

plugin(
    AnimatedRaster
    animated_raster.py
)

plugin(
    dotLottie
    dotlottie.py
    icon.svg
)

plugin(
    Synfig
    synfig.py
)

plugin(
    HueShift
    hue_shift.py
)


plugin(
    FrameByFrame
    create_frames.py
    create_frames.ui
)

=== docs/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2019-2023 Mattia Basaglia <dev@dragon.best>
# SPDX-License-Identifier: BSD-2-Clause

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/mkdocs.in.yml" "${CMAKE_CURRENT_SOURCE_DIR}/mkdocs.yml")

add_custom_target(
    docs
    COMMAND "PYTHONPATH=${CMAKE_CURRENT_SOURCE_DIR}/extensions/" mkdocs build -f "${CMAKE_CURRENT_SOURCE_DIR}/mkdocs.yml" -d "${CMAKE_CURRENT_BINARY_DIR}/site"
    DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/mkdocs.yml"
    DEPENDS docs_build_python
)

add_custom_target(
    docs_serve
    COMMAND "PYTHONPATH=${CMAKE_CURRENT_SOURCE_DIR}/extensions/" mkdocs serve -f "${CMAKE_CURRENT_SOURCE_DIR}/mkdocs.yml"
    DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/mkdocs.yml"
)

if(PYTHON_PIP)
    add_custom_target(
        docs_depends_install
        COMMAND ${PYTHON_PIP} install mkdocs mkdocs-cinder git+https://github.com/mbasaglia/fontawesome-markdown.git@fix babel requests mkdocs-simple-hooks
    )
endif()


add_custom_command(
    OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/docs/img/favicon.png
    COMMAND inkscape ${CMAKE_SOURCE_DIR}/data/logo/favicon.svg -o ${CMAKE_CURRENT_SOURCE_DIR}/docs/img/favicon.png
    DEPENDS ${CMAKE_SOURCE_DIR}/data/logo/favicon.svg
)

add_custom_target(
    docs_build_python
    COMMAND PYTHONPATH=${CMAKE_BINARY_DIR}/bin/python/build/lib ${Python3_EXECUTABLE} "${CMAKE_CURRENT_SOURCE_DIR}/build_py_doc.py" "${CMAKE_CURRENT_SOURCE_DIR}/docs/contributing/scripting/python_reference.md" "${CMAKE_CURRENT_BINARY_DIR}/json_reference.md"
    COMMAND cat "${CMAKE_CURRENT_SOURCE_DIR}/json_reference.in.md" "${CMAKE_CURRENT_BINARY_DIR}/json_reference.md" >"${CMAKE_CURRENT_SOURCE_DIR}/docs/contributing/json_reference.md"
    BYPRODUCTS "${CMAKE_CURRENT_SOURCE_DIR}/docs/contributing/scripting/python_reference.md" "${CMAKE_CURRENT_SOURCE_DIR}/docs/contributing/json_reference.md"
    DEPENDS glaxnimate_python
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/docs/img/favicon.png
)

=== test/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2019-2023 Mattia Basaglia <dev@dragon.best>
# SPDX-License-Identifier: BSD-2-Clause

message(STATUS "Test targets enabled")
set(SOURCE_BASE_DIR ${CMAKE_SOURCE_DIR}/src)
set(COVERAGE_TOOL "gcovr")
#set(COVERAGE_REMOVE_PATTERNS "/usr/.*")
set(COVERAGE_FILTER_PATTERNS ".*/src/core/.*")
include(testing)

include_directories(${CMAKE_SOURCE_DIR}/src)
include_directories(${CMAKE_BINARY_DIR}/bin)
include_directories(${CMAKE_SOURCE_DIR}/external/QtAppSetup/src)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage")


function(test_case test_name)
    add_executable(${test_name} EXCLUDE_FROM_ALL ${test_name}.cpp ${ARGN})
    target_link_libraries(${test_name} PRIVATE Qt${QT_VERSION_MAJOR}::Test Qt${QT_VERSION_MAJOR}::Widgets QtColorWidgets QtAppSetup)
    add_test (NAME ${test_name} COMMAND ${test_name} -silent)
    add_dependencies(tests_compile ${test_name})
    set_property(TARGET ${test_name} APPEND PROPERTY AUTOMOC_MACRO_NAMES "GLAXNIMATE_OBJECT")
endfunction(test_case)

include_directories(${CMAKE_SOURCE_DIR}/src/core)

test_case(test_property)
target_link_libraries(test_property PRIVATE ${LIB_NAME_CORE})

test_case(test_bezier_solver)

test_case(test_bezier_length
../src/core/math/bezier/bezier.cpp
../src/core/math/bezier/point.cpp
../src/core/math/bezier/bezier_length.cpp
)

test_case(test_keyframe_transition
../src/core/model/animation/keyframe_transition.cpp
../src/core/math/polynomial.cpp
)

test_case(test_trim_path)
target_link_libraries(test_trim_path PRIVATE ${LIB_NAME_CORE})


test_case(test_trace)
target_link_libraries(test_trace PRIVATE ${LIB_NAME_CORE})

test_case(test_riff)

test_case(test_cos_parser
../src/core/io/aep/string_decoder.cpp
)

test_case(test_aep_gradient_xml)
target_link_libraries(test_aep_gradient_xml PRIVATE ${LIB_NAME_CORE})

=== external/QtAppSetup/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.13 FATAL_ERROR)
cmake_policy(SET CMP0076 NEW)

project(QtAppSetup VERSION 0.1.0 LANGUAGES CXX)
set(PROJECT_SLUG QtAppSetup)

# C++
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Qt
find_package(Qt${QT_VERSION_MAJOR}Qml QUIET)
find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Widgets REQUIRED)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Submodules
add_subdirectory(src)

option(SCRIPTING_JS "Enable JS scripting" OFF)
if(Qt5Qml_FOUND AND SCRIPTING_JS)
    message(STATUS "JS enabled")
    add_subdirectory(src/app/scripting/js/)
endif()


option(SCRIPTING_PY "Enable Python scripting" OFF)
find_package(Python3 COMPONENTS Interpreter Development QUIET)
if(Python3_FOUND AND SCRIPTING_PY)
    set(PYTHON_ENABLED ON PARENT_SCOPE)
    message(STATUS "Python3 enabled")
    add_subdirectory(external/pybind11)
    add_subdirectory(src/app/scripting/python)
    target_include_directories (${PROJECT_SLUG} PUBLIC
        ${Python3_INCLUDE_DIRS}
        ${CMAKE_CURRENT_SOURCE_DIR}/external/pybind11/include
    )
else()
    set(PYTHON_ENABLED OFF PARENT_SCOPE)
endif()

=== external/potrace/CMakeLists.txt ===
project(potrace C)

include_directories(src/)

set(SOURCES
    src/potracelib.c
    src/decompose.c
    src/trace.c
    src/curve.c
)

add_compile_definitions(VERSION="1.16")

add_library(potrace ${SOURCES})

=== src/android/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2019-2023 Mattia Basaglia <dev@dragon.best>
# SPDX-License-Identifier: BSD-2-Clause

set(SOURCES
    android_file_picker.cpp
    android_intent_handler.cpp
    android_style.cpp
    base_dialog.cpp
    better_toolbox_widget.cpp
    document_opener.cpp
    format_selection_dialog.cpp
    help_dialog.cpp
    main.cpp
    main_window.cpp
    main_window.ui
    sticker_pack_builder_dialog.cpp
    sticker_pack_builder_dialog.ui
    telegram_intent.cpp
    timeline_slider.cpp
)

if(NOT ANDROID)
    add_compile_definitions(Q_OS_ANDROID_FAKE)
endif()

include_directories(
    ${CMAKE_SOURCE_DIR}/external/QtAppSetup/src
    ${CMAKE_SOURCE_DIR}/src/core
    ${CMAKE_SOURCE_DIR}/src/gui
    ${CMAKE_SOURCE_DIR}/external/QtColorWidgets/include
)

if (ANDROID)
    find_package(Qt${QT_VERSION_MAJOR} COMPONENTS AndroidExtras Svg REQUIRED)
endif()

add_executable(${PROJECT_SLUG}_mobile ${SOURCES})

target_link_libraries(${PROJECT_SLUG}_mobile PUBLIC
    QtAppSetup
    ${LIB_NAME_CORE}
    ${LIB_NAME_GUI}
    QtColorWidgets
    #QtHistoryLineEdit
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::UiTools
    Qt${QT_VERSION_MAJOR}::Concurrent
)

if (ANDROID)
    target_link_libraries(${PROJECT_SLUG}_mobile PUBLIC
        Qt${QT_VERSION_MAJOR}::AndroidExtras
        Qt${QT_VERSION_MAJOR}::Svg
    )
endif()

string(TIMESTAMP VERSION_CODE "%s" UTC)

#install(TARGETS ${PROJECT_SLUG}_mobile ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
install(TARGETS ${PROJECT_SLUG}_mobile)

# Download Twemoji
add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/emoji
    COMMAND rm -r -f /tmp/noto-emoji-main
    COMMAND git clone https://github.com/googlefonts/noto-emoji.git /tmp/noto-emoji-main
    COMMAND mkdir ${CMAKE_CURRENT_BINARY_DIR}/emoji
    COMMAND mv -T /tmp/noto-emoji-main/svg ${CMAKE_CURRENT_BINARY_DIR}/emoji/svg
    COMMAND mv -T /tmp/noto-emoji-main/png/72 ${CMAKE_CURRENT_BINARY_DIR}/emoji/png
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/tools/copy_emoji_flags.py /tmp/noto-emoji-main/third_party/region-flags/svg/ ${CMAKE_CURRENT_BINARY_DIR}/emoji/svg
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/tools/copy_emoji_flags.py /tmp/noto-emoji-main/third_party/region-flags/png/ ${CMAKE_CURRENT_BINARY_DIR}/emoji/png
)
add_custom_target(emoji_images
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/emoji
)
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/emoji DESTINATION ${DATA_INSTALL} PATTERN *@* EXCLUDE)
add_dependencies(${PROJECT_SLUG}_mobile emoji_images)
message(STATUS ${DATA_INSTALL}/emoji)

# Lists virtual devices
add_custom_target(
    android_avd_list
    COMMAND "${ANDROID_SDK}/emulator/emulator" -list-avds
)

# Starts a virtual device
# Usage:
#   make android_avd_start DEVICE="device"
# where "device" is from `android_avd_list`
add_custom_target(
    android_avd_start
    COMMAND "${ANDROID_SDK}/emulator/emulator" -avd "$$DEVICE" &
)

# Same as android_avd_start but starts from a clean state
add_custom_target(
    android_avd_clean_start
    COMMAND "${ANDROID_SDK}/emulator/emulator" -avd "$$DEVICE" -no-snapshot &
)


# # Installs (and runs the apk)
# add_custom_target(
#     android_install
#     COMMAND adb install -r $<TARGET_PROPERTY:${PROJECT_SLUG}_mobile,apk>
#     COMMAND adb shell am force-stop ${PACKAGE_NAME}
#     COMMAND adb shell am start -n ${PACKAGE_NAME}/.GlaxnimateActivity -W
#     #DEPENDS ${PROJECT_SLUG}_mobile
# )

# Attaches to the logs of the running app
add_custom_target(
    android_log
    COMMAND adb logcat --pid `adb shell ps -o PID,ARGS | grep -F ${PACKAGE_NAME} | sed -r "'s/^\\s*([0-9]+).*/\\1/'" `
)

=== src/core/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2019-2023 Mattia Basaglia <dev@dragon.best>
# SPDX-License-Identifier: BSD-2-Clause

set(SOURCES

app_info.cpp

command/structure_commands.cpp
command/shape_commands.cpp
command/animation_commands.cpp

io/base.cpp
io/binary_stream.cpp
io/utils.cpp
io/glaxnimate/glaxnimate_format.cpp
io/glaxnimate/glaxnimate_importer.cpp
io/glaxnimate/glaxnimate_mime.cpp
io/lottie/cbor_write_json.cpp
io/lottie/lottie_format.cpp
io/lottie/lottie_html_format.cpp
io/lottie/tgs_format.cpp
io/lottie/validation.cpp
io/mime/mime_serializer.cpp
io/raster/raster_format.cpp
io/raster/spritesheet_format.cpp
io/rive/rive_format.cpp
io/rive/rive_html_format.cpp
io/rive/rive_loader.cpp
io/rive/rive_serializer.cpp
io/rive/type_def.cpp
io/rive/type_system.cpp
io/svg/detail.cpp
io/svg/svg_format.cpp
io/svg/svg_parser.cpp
io/svg/svg_renderer.cpp
io/avd/avd_parser.cpp
io/avd/avd_format.cpp
io/avd/avd_renderer.cpp
io/aep/aep_format.cpp
io/aep/aep_loader.cpp
io/aep/string_decoder.cpp
io/aep/gradient_xml.cpp

math/geom.cpp
math/polynomial.cpp
math/ellipse_solver.cpp
math/bezier/bezier.cpp
math/bezier/point.cpp
math/bezier/operations.cpp
math/bezier/cubic_struts.cpp
math/bezier/meta.cpp
math/bezier/bezier_length.cpp

model/document.cpp
model/document_node.cpp
model/object.cpp
model/transform.cpp
model/factory.cpp
model/animation_container.cpp
model/stretchable_time.cpp
model/comp_graph.cpp
model/mask_settings.cpp
model/visitor.cpp
model/custom_font.cpp

model/animation/keyframe_transition.cpp
model/animation/animatable.cpp
model/animation/animatable_path.cpp
model/property/property.cpp
model/property/reference_property.cpp
model/property/option_list_property.cpp

model/assets/assets.cpp
model/assets/brush_style.cpp
model/assets/named_color.cpp
model/assets/bitmap.cpp
model/assets/gradient.cpp
model/assets/asset_base.cpp
model/assets/asset.cpp
model/assets/composition.cpp
model/assets/embedded_font.cpp
model/assets/network_downloader.cpp

model/shapes/shape.cpp
model/shapes/fill.cpp
model/shapes/rect.cpp
model/shapes/group.cpp
model/shapes/ellipse.cpp
model/shapes/path.cpp
model/shapes/stroke.cpp
model/shapes/polystar.cpp
model/shapes/styler.cpp
model/shapes/layer.cpp
model/shapes/image.cpp
model/shapes/precomp_layer.cpp
model/shapes/text.cpp
model/shapes/repeater.cpp
model/shapes/trim.cpp
model/shapes/inflate_deflate.cpp
model/shapes/path_modifier.cpp
model/shapes/round_corners.cpp
model/shapes/offset_path.cpp
model/shapes/zig_zag.cpp

plugin/plugin.cpp
plugin/action.cpp
plugin/io.cpp

utils/gzip.cpp
utils/quantize.cpp
utils/trace.cpp
utils/trace_wrapper.cpp
)

if ( NOT ANDROID )
    list(APPEND SOURCES
        io/video/video_format.cpp
        utils/tar.cpp
    )
    find_package(Libav COMPONENTS codec util format swscale REQUIRED)
    include_directories(${Libav_INCLUDE_DIRS})

    find_package(LibArchive REQUIRED)
    include_directories(${LibArchive_INCLUDE_DIRS})
endif()

find_package(ZLIB REQUIRED)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/application_info_generated.in.hpp
    ${CMAKE_CURRENT_BINARY_DIR}/application_info_generated.hpp
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_SOURCE_DIR}/external/QtAppSetup/src)

if ( GLAXNIMATE_SYSTEM_POTRACE )
    include_directories(${Potrace_INCLUDE_DIRS})
endif()

add_library(${LIB_NAME_CORE} OBJECT ${SOURCES})
target_link_libraries(${LIB_NAME_CORE} PUBLIC QtAppSetup ZLIB::ZLIB Qt${QT_VERSION_MAJOR}::Xml Qt${QT_VERSION_MAJOR}::Network ${Potrace_LIBRARIES})
set_property(TARGET ${LIB_NAME_CORE} APPEND PROPERTY AUTOMOC_MACRO_NAMES "GLAXNIMATE_OBJECT")
target_include_directories(${LIB_NAME_CORE} PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)

if ( NOT ANDROID )
    target_link_libraries(${LIB_NAME_CORE} PUBLIC ${Libav_LIBRARIES} ${LibArchive_LIBRARIES} )
endif()

=== external/QtAppSetup/src/app/scripting/js/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2019-2023 Mattia Basaglia <dev@dragon.best>
#
# SPDX-License-Identifier: GPL-3.0-or-later

target_sources(${PROJECT_SLUG} PRIVATE
    js_engine.cpp
)

target_link_libraries(${PROJECT_SLUG} PUBLIC ${Qt5Qml_LIBRARIES})

=== external/QtAppSetup/src/app/scripting/python/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2019-2023 Mattia Basaglia <dev@dragon.best>
#
# SPDX-License-Identifier: GPL-3.0-or-later

target_sources(${PROJECT_SLUG} PRIVATE
    python_engine.cpp
    register_machinery.cpp
)

message(STATUS "Python3_INCLUDE_DIRS ${Python3_INCLUDE_DIRS}")
message(STATUS "Python3_LIBRARIES ${Python3_LIBRARIES}")
message(STATUS "Python3_EXECUTABLE ${Python3_EXECUTABLE}")
target_link_libraries(${PROJECT_SLUG} PUBLIC ${Python3_LIBRARIES})

=== deploy/PKGBUILD ===
# Maintainer: Sythelux Rikd <dersyth@gmail.com>
# Maintainer: Mattia Basaglia <glax@dragon.best>
_corpname=glaxnimate
_pkgname='glaxnimate'
pkgname="$_pkgname"
_git_branch="release"
pkgver=0.5.0
pkgrel=1
pkgdesc="Simple vector animation program."
url="https://glaxnimate.mattbas.org/"
license=('GPL3')
arch=('x86_64' 'i686' 'armv7h' 'aarch64' 'riscv32' 'riscv64')
makedepends=('git' 'cmake' 'make' 'gcc' 'qt6-declarative')
depends=('python' 'zlib' 'hicolor-icon-theme' 'potrace' 'ffmpeg' 'libarchive' 'qt6-tools' 'qt6-base' 'qt6-imageformats' 'qt6-svg')
provides=("$_pkgname")
conflicts=("$_pkgname")
source=(
    "$_pkgname::git+https://gitlab.com/mattbas/$_pkgname/#branch=$_git_branch"
)
sha256sums=('SKIP')

prepare() {
    cd "$_pkgname/"

    # Provide git submodules
    git submodule init
    git submodule update --init --recursive
}

pkgver() {
    cd "$srcdir/$_pkgname/"
    git describe --tags | tr - _
}

build() {
    cd "$srcdir/$_pkgname/"
    mkdir -p build
    cd build
    cmake ".." -DCMAKE_INSTALL_PREFIX=/usr
    # For more build jobs:
    # echo 'MAKEFLAGS="-j4"' >>/etc/makepkg.conf
    # (or ~/.makepkg.conf)
    make
    make translations VERBOSE=1
}

package() {
    cd "$srcdir/$_pkgname/build"
    make install DESTDIR=$pkgdir >/dev/null
}
